/*
		cgi/g77 functions library
		-------------------------

		http://krabulator.free.fr/devel/cgi77.html
		oulala@chez.com

	This library is released under the LGPL license.
	Use it as you want, but remember that: "ymmv".

	* only tested under GNU/Linux glibc kernel 2.2.x
	* compilers versions:
	* gcc version egcs-2.91.66 19990314 (egcs-1.1.2 release)
	* g77 version egcs-2.91.66 19990314 (egcs-1.1.2 release)

*/

#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>

#include  "cgi77.h"

/* -------------------------------------------------------------------- */

int
cgi77_remport__(long *pport)
{
char	*cptr;
long	port;

if ( (cptr = getenv("REMOTE_PORT")) == NULL )
	{
	return 0;
	}

#if TRACE
fprintf(stderr, "cgi77: get remote port: cptr = [%s]\n", cptr);
#endif

if ( (sscanf(cptr, "%ld", &port)) != 1 )
	{
#if TRACE
fprintf(stderr, "err sscanf ?\n");
#endif
	return 0;
	}

*pport = port;
return 1;
}

/* -------------------------------------------------------------------- */
int
cgi77_remaddr__(char *dest, int hidden)
{
char	*cptr;
int	taille;

cptr = getenv("REMOTE_ADDR");

if (cptr == NULL)		return 0;

taille = strlen(cptr);
if (taille >= hidden)		return 99;

memset(dest, ' ', hidden);
strncpy(dest, cptr, taille);

#if TRACE
fprintf(stderr, "cgi77: remoteaddr: return OK %s\n", dest);
#endif
return 1;
}

/* -------------------------------------------------------------------- */

int
cgi77_remhost__(char *dest, int hidden)
{
char	*cptr;
int	taille;

#if TRACE
fprintf(stderr, "cgi77: remotehost: taille buffer = %d\n", hidden);
#endif

cptr = getenv("REMOTE_HOST");

if (cptr == NULL)
	{
#if TRACE
	fprintf(stderr, "cgi77: no REMOTE_HOST envvar\n");
#endif
	return 0;
	}
#if TRACE
else
	{
	fprintf(stderr, "cgi77: REMOTE_HOST = %s\n", cptr);
	}
#endif

taille = strlen(cptr);
#if TRACE
// fprintf(stderr, "cgi77: strlen(remote_host) = %d, hidden = %d\n", taille, hidden);
#endif

if (taille >= hidden)		return 99;

memset(dest, ' ', hidden);
strncpy(dest, cptr, taille);

#if TRACE
fprintf(stderr, "cgi77: get remote host OK.\n");
#endif

return 1;
}

/* -------------------------------------------------------------------- */
