/*
		cgi/g77 functions library
		-------------------------

		http://krabulator.free.fr/devel/cgi77.html
		oulala@chez.com

	This library is released under the LGPL license.
	Use it as you want, but remember that: "ymmv".

	* only tested under GNU/Linux glibc kernel 2.2.x
	* compilers versions:
	* gcc version egcs-2.91.66 19990314 (egcs-1.1.2 release)
	* g77 version egcs-2.91.66 19990314 (egcs-1.1.2 release)

*/

#include  <stdio.h>
#include  <strings.h>
#include  <stdlib.h>

#include  "cgi77.h"

/* -------------------------------------------------------------------- */
int
cgi77_server_name__(char *srvname, int hidden)
{
char	*cptr;
int	taille;

if ( (cptr=getenv("SERVER_NAME")) == NULL )
	{
#if TRACE
	fprintf(stderr, "cgi77: no SERVER_NAME available\n");
#endif
	return 0;
	}

taille = strlen(cptr);
if (taille >= hidden)
	{
#if TRACE
	fprintf(stderr, "cgi77: space %d > size of server name %d\n",
					taille, hidden);
#endif
	return 99;
	}

memset(srvname, ' ', hidden);
strncpy(srvname, cptr, taille);

#if TRACE
fprintf(stderr, "cgi77: the server name is %s\n", cptr);
#endif

return 1;
}
/* -------------------------------------------------------------------- */
int
cgi77_server_soft__(char *srvsoft, int hidden)
{
char	*cptr;
int	taille;


if ( (cptr=getenv("SERVER_SOFTWARE")) == NULL )
	{
	return 0;
	}

taille = strlen(cptr);
if (taille >= hidden)
	{
	return 99;
	}

memset(srvsoft, ' ', hidden);
strncpy(srvsoft, cptr, taille);

#if TRACE
fprintf(stderr, "cgi77: the server software is %s\n", cptr);
#endif

return 1;
}
/* -------------------------------------------------------------------- */
